(*
+------------------------------------------------------------------------------+
|              Win32           |
|                           (c)  ..                                   |
|                        mailto:dark@online.ru                                 |
|                    http://www.inta.portal.ru/dark/                           |
|        "Delphi  "  |
|                             .  2002                                  |
|                                                                              |
|                      :                          |
| 1.  :   Uses  RusErrorStr                    |
| 2.  MessageBox'   :                                      |
|              SysErrorMessage(GetLastError)                      |
|                                                                              |
|           |
|                          .                              |
+------------------------------------------------------------------------------+
*)
{
    23  2005
(c) Sergey D. Shcherbakov 2005
  :
1.     
  ErrorStr(ErrorCode:Integer):String;
2.  
  SysErrorMessageC();
          
    .
3.  
  SysErrorMessageCA(MText:String);
       SysErrorMessageC 
   -    
   .
5.      (FileName), 
   (MText).
   SysLog(FileName,MText:String);
6.      (FileName) 
  ,     (MText), 
       
  (MsgBox = True).
  SysErrorLogCA(FileName,MText:String;MsgBox:Boolean);
}

unit RusErrorStr;

interface
Uses
  Windows, Forms ;

function  ErrorStr(ErrorCode:Integer):String;
Procedure SysErrorMessage(ErrorCode:Integer);
Procedure SysErrorMessageC;
Procedure SysErrorMessageCA(MText:String);
Procedure SysLog(FileName,MText:String);
Procedure SysErrorLogCA(FileName,MText:String;MsgBox:Boolean);

implementation

uses SysUtils;

function  ErrorStr(ErrorCode:Integer):String;
Begin
  Case ErrorCode Of
    0:ErrorStr:='  !';
    1:ErrorStr:=' !';
    2:ErrorStr:='     !';
    3:ErrorStr:='     !';
    4:ErrorStr:='    !';
    5:ErrorStr:=' !';
    6:ErrorStr:=' !';
    7:ErrorStr:='   !';
    8:ErrorStr:='    !';
    9:ErrorStr:='    !';
    10:ErrorStr:='  !';
    11:ErrorStr:='  ,   !';
    12:ErrorStr:='  !';
    13:ErrorStr:='  !';
    14:ErrorStr:='    !';
    15:ErrorStr:='     !';
    16:ErrorStr:='   !';
    17:ErrorStr:='       !';
    18:ErrorStr:='   !';
    19:ErrorStr:='   !';
    20:ErrorStr:='     !';
    21:ErrorStr:='  !';
    22:ErrorStr:='   !';
    23:ErrorStr:='   (CRC)!';
    24:ErrorStr:='     !';
    25:ErrorStr:='        !';
    26:ErrorStr:='      !';
    27:ErrorStr:='      !';
    28:ErrorStr:='   !';
    29:ErrorStr:='      !';
    30:ErrorStr:='      !';
    31:ErrorStr:='     !';
    32:ErrorStr:='      ,       !';
    33:ErrorStr:='      ,        !';
    34:ErrorStr:='    !';
    36:ErrorStr:='      !';
    38:ErrorStr:='  !';
    39:ErrorStr:='   !';
    50:ErrorStr:='   !';
    51:ErrorStr:='   !';
    52:ErrorStr:='    !';
    53:ErrorStr:='   !';
    54:ErrorStr:=' !';
    55:ErrorStr:='     !';
    56:ErrorStr:='    NetBIOS!';
    57:ErrorStr:='   !';
    58:ErrorStr:='      !';
    59:ErrorStr:='   !';
    60:ErrorStr:='  !';
    61:ErrorStr:='  !';
    62:ErrorStr:='      ,   !';
    63:ErrorStr:=',     ,  !';
    64:ErrorStr:='    !';
    65:ErrorStr:='   !';
    66:ErrorStr:='    !';
    67:ErrorStr:='   !';
    68:ErrorStr:='         !';
    69:ErrorStr:='     NetBIOS!';
    70:ErrorStr:='        !';
    71:ErrorStr:='        ,      !';
    72:ErrorStr:='       !';
    80:ErrorStr:=' !';
    82:ErrorStr:='     !';
    83:ErrorStr:='     INT 24!';
    84:ErrorStr:='    !';
    85:ErrorStr:='    !';
    86:ErrorStr:='   !';
    87:ErrorStr:='  !';
    88:ErrorStr:='   !';
    89:ErrorStr:='        !';
    100:ErrorStr:='      !';
    101:ErrorStr:='     !';
    102:ErrorStr:='      !';
    103:ErrorStr:='     !';
    104:ErrorStr:='          !';
    105:ErrorStr:='       !';
    106:ErrorStr:='   !';
    107:ErrorStr:='  ,       !';
    108:ErrorStr:='     !';
    109:ErrorStr:='  !';
    110:ErrorStr:='       !';
    111:ErrorStr:='    !';
    112:ErrorStr:='   !';
    113:ErrorStr:='   !';
    114:ErrorStr:='    !';
    117:ErrorStr:=' IOCTL   !';
    118:ErrorStr:='     !';
    119:ErrorStr:='     !';
    120:ErrorStr:='      Win32!';
    121:ErrorStr:='   !';
    122:ErrorStr:=' ,    ,  !';
    123:ErrorStr:='    ,     !';
    124:ErrorStr:='   !';
    125:ErrorStr:='    !';
    126:ErrorStr:='   !';
    127:ErrorStr:='   !';
    128:ErrorStr:=' ,    , !';
    129:ErrorStr:='     Win32!';
    130:ErrorStr:='          ,   -  !';
    131:ErrorStr:='       !';
    132:ErrorStr:='           !';
    133:ErrorStr:=' JOIN  SUBST      ,    !';
    134:ErrorStr:='   JOIN  SUBST  ,      !';
    135:ErrorStr:='   JOIN  SUBST  ,    !';
    136:ErrorStr:='     ,    JOIN  !';
    137:ErrorStr:='     ,    SUBST  !';
    138:ErrorStr:='       !';
    139:ErrorStr:='    ,    !';
    140:ErrorStr:='       !';
    141:ErrorStr:='    ,    !';
    142:ErrorStr:='     JOIN  SUBST !';
    143:ErrorStr:='  ( )    (  )   !';
    144:ErrorStr:='       !';
    145:ErrorStr:='  !';
    146:ErrorStr:='     !';
    147:ErrorStr:='    !';
    148:ErrorStr:='      !';
    149:ErrorStr:='    ,       !';
    150:ErrorStr:='     Config.sys  ,   !';
    151:ErrorStr:='   DosMuxSemWait  !';
    152:ErrorStr:='   DosMuxSemWait.    !';
    153:ErrorStr:='  DosMuxSemWait!';
    154:ErrorStr:='    ,    !';
    155:ErrorStr:='      !';
    156:ErrorStr:='   !';
    157:ErrorStr:='       !';
    158:ErrorStr:='   !';
    159:ErrorStr:='     !';
    160:ErrorStr:='DosExecPgm   !';
    161:ErrorStr:='  !';
    162:ErrorStr:='     !';
    164:ErrorStr:='    !';
    167:ErrorStr:='      !';
    170:ErrorStr:='  !';
    173:ErrorStr:='     !';
    174:ErrorStr:='       !';
    180:ErrorStr:='    !';
    183:ErrorStr:='  , ..   !';
    186:ErrorStr:='  !';
    187:ErrorStr:='     !';
    196:ErrorStr:='      !';
    197:ErrorStr:='       !';
    199:ErrorStr:='     64 !';
    200:ErrorStr:='      !';
    203:ErrorStr:='      !';
    205:ErrorStr:='          !';
    206:ErrorStr:='        !';
    207:ErrorStr:=' !';
    208:ErrorStr:='  */?       !';
    209:ErrorStr:='  !';
    210:ErrorStr:='    !';
    212:ErrorStr:='      !';
    214:ErrorStr:='          !';
    230:ErrorStr:='  !';
    231:ErrorStr:='   !';
    232:ErrorStr:='  !';
    233:ErrorStr:='     !';
    234:ErrorStr:='  !';
    240:ErrorStr:='  !';
    254:ErrorStr:='     !';
    255:ErrorStr:='    !';
    259:ErrorStr:='  !';
    266:ErrorStr:='    API Copy!';
    267:ErrorStr:='   !';
    275:ErrorStr:='     !';
    276:ErrorStr:='   !';
    277:ErrorStr:='   !';
    278:ErrorStr:='    !';
    282:ErrorStr:='      !';
    288:ErrorStr:='      !';
    298:ErrorStr:='      !';
    299:ErrorStr:=' Read/WriteProcessMemory   !';
    487:ErrorStr:='    !';
    534:ErrorStr:='     32 !';
    535:ErrorStr:='     !';
    536:ErrorStr:='      !';
    994:ErrorStr:='    !';
    995:ErrorStr:=' -   -       !';
    996:ErrorStr:='  -     !';
    997:ErrorStr:='   -!';
    998:ErrorStr:='     !';
    999:ErrorStr:='     !';
    1001:ErrorStr:='   .  !';
    1002:ErrorStr:='      !';
    1003:ErrorStr:='    !';
    1004:ErrorStr:='  !';
    1005:ErrorStr:='       .   ,     ,      !';
    1006:ErrorStr:='       ,     !';
    1007:ErrorStr:='        !';
    1008:ErrorStr:='    !';
    1009:ErrorStr:='   !';
    1010:ErrorStr:='    !';
    1011:ErrorStr:='    !';
    1012:ErrorStr:='    !';
    1013:ErrorStr:='    !';
    1014:ErrorStr:='               .   !';
    1015:ErrorStr:=' .    ,   , .            -   / !';
    1016:ErrorStr:='   -,   .          ,    !';
    1017:ErrorStr:='       ,      !';
    1018:ErrorStr:='      ,   !';
    1019:ErrorStr:='       !';
    1020:ErrorStr:='      ,      !';
    1021:ErrorStr:='       !';
    1022:ErrorStr:='     ,         .          !';
    1051:ErrorStr:='    ,     !';
    1052:ErrorStr:='    !';
    1053:ErrorStr:='     !';
    1054:ErrorStr:='     !';
    1055:ErrorStr:='   !';
    1056:ErrorStr:='    !';
    1057:ErrorStr:='       !';
    1058:ErrorStr:='       !';
    1059:ErrorStr:='       !';
    1060:ErrorStr:='   !';
    1061:ErrorStr:='       !';
    1062:ErrorStr:='  !';
    1063:ErrorStr:='        !';
    1064:ErrorStr:='    !';
    1065:ErrorStr:='    !';
    1066:ErrorStr:='   !';
    1067:ErrorStr:='   !';
    1068:ErrorStr:='    !';
    1069:ErrorStr:='   -   !';
    1070:ErrorStr:='    ""!';
    1071:ErrorStr:='      !';
    1072:ErrorStr:='     !';
    1073:ErrorStr:='   !';
    1074:ErrorStr:='         !';
    1075:ErrorStr:='        !';
    1076:ErrorStr:='           !';
    1077:ErrorStr:='       !';
    1078:ErrorStr:='      !';
    1100:ErrorStr:='   !';
    1101:ErrorStr:='  !';
    1102:ErrorStr:='   !';
    1103:ErrorStr:='   !';
    1104:ErrorStr:='    !';
    1105:ErrorStr:='     !';
    1106:ErrorStr:='            !';
    1107:ErrorStr:='        !';
    1108:ErrorStr:='     !';
    1109:ErrorStr:='   !';
    1110:ErrorStr:='      !';
    1111:ErrorStr:=' -   !';
1112:ErrorStr:='   !';
1113:ErrorStr:=' Unicode       !';
1114:ErrorStr:='        (DLL)!';
1115:ErrorStr:='   !';
1116:ErrorStr:='    ,      !';
1117:ErrorStr:='    -  -  !';
1118:ErrorStr:='   .   !';
1119:ErrorStr:='   ,         (IRQ).    ,     IRQ,   !';
1120:ErrorStr:='  -           ( IOCTLSERIALXOFFCOUNTER  0!';
1121:ErrorStr:='  -       ( IOCTLSERIALOFFCOUNTER   0)!';
1122:ErrorStr:='       !';
1123:ErrorStr:='           !';
1124:ErrorStr:=',    ,   !';
1125:ErrorStr:='      !';
1126:ErrorStr:='         !';
1127:ErrorStr:='        !';
1128:ErrorStr:='       ,      !';
1129:ErrorStr:='   !';
1130:ErrorStr:='     !';
1131:ErrorStr:='    !';
1132:ErrorStr:='      !';
1140:ErrorStr:='         !';
1141:ErrorStr:=' BIOS     !';
1150:ErrorStr:='       Windows!';
1151:ErrorStr:='      Windows  MS-DOS!';
1152:ErrorStr:='     !';
1153:ErrorStr:='         Windows!';
1154:ErrorStr:='    ,     !';
1155:ErrorStr:='          !';
1156:ErrorStr:='    !';
1157:ErrorStr:='     ,     !';
2202:ErrorStr:='   !';
2250:ErrorStr:='   !';
2401:ErrorStr:='       ,  !';
2402:ErrorStr:='    !';
2404:ErrorStr:='          !';
1200:ErrorStr:='   !';
1201:ErrorStr:='     ,       !';
1202:ErrorStr:='    ,   !';
1203:ErrorStr:='            !';
1204:ErrorStr:='      !';
1205:ErrorStr:='      !';
1206:ErrorStr:='    !';
1207:ErrorStr:='  ,   , !';
1208:ErrorStr:='!';
1209:ErrorStr:='   !';
1210:ErrorStr:='   !';
1211:ErrorStr:='   !';
1212:ErrorStr:='   !';
1213:ErrorStr:='   !';
1214:ErrorStr:='   !';
1215:ErrorStr:='   !';
1216:ErrorStr:='  !';
1217:ErrorStr:='   !';
1218:ErrorStr:='   ,    !';
1219:ErrorStr:='       !';
1220:ErrorStr:='      .        !';
1221:ErrorStr:='          !';
1222:ErrorStr:='    !';
1223:ErrorStr:='   !';
1224:ErrorStr:='          !';
1225:ErrorStr:='       !';
1226:ErrorStr:='   !';
1227:ErrorStr:='      !';
1228:ErrorStr:='      !';
1229:ErrorStr:='      !';
1230:ErrorStr:='       !';
1231:ErrorStr:='    !';
1232:ErrorStr:='       !';
1233:ErrorStr:='     !';
1234:ErrorStr:='           !';
1235:ErrorStr:='  !';
1236:ErrorStr:='      !';
1237:ErrorStr:='   .   !';
1238:ErrorStr:='   ,             !';
1239:ErrorStr:='         ( )  !';
1240:ErrorStr:='        !';
1241:ErrorStr:='      !';
1242:ErrorStr:='  !';
1243:ErrorStr:='   !';
1244:ErrorStr:='    ,     !';
1245:ErrorStr:='    ,       .    !';
1246:ErrorStr:='   ,   !';
1247:ErrorStr:='   ,   !';
1248:ErrorStr:='    !';
1300:ErrorStr:='      !';
1301:ErrorStr:='         !';
1302:ErrorStr:='      !';
1303:ErrorStr:='  !';
1304:ErrorStr:=' NT          LAN Manager.   LAN Manager    !';
1305:ErrorStr:='   !';
1306:ErrorStr:='    !';
1307:ErrorStr:='       !';
1308:ErrorStr:='        !';
1309:ErrorStr:='      ,        !';
1310:ErrorStr:='  !';
1311:ErrorStr:=' ,         !';
1312:ErrorStr:='      . ,   !';
1313:ErrorStr:='   !';
1314:ErrorStr:='    !';
1315:ErrorStr:='      !';
1316:ErrorStr:='     !';
1317:ErrorStr:='     !';
1318:ErrorStr:='   !';
1319:ErrorStr:='   !';
1320:ErrorStr:='      ,      ,       !';
1321:ErrorStr:='      !';
1322:ErrorStr:='         !';
1323:ErrorStr:='   .     !';
1324:ErrorStr:='   .     !';
1325:ErrorStr:='   .      !';
1326:ErrorStr:='    :   ( )  !';
1327:ErrorStr:='    :  ,    !';
1328:ErrorStr:='    :         !';
1329:ErrorStr:='    :        !';
1330:ErrorStr:='    :     !';
1331:ErrorStr:='    :      !';
1332:ErrorStr:='      !';
1333:ErrorStr:='      !';
1334:ErrorStr:='    !';
1335:ErrorStr:='    !';
1336:ErrorStr:='   (ACL)   !';
1337:ErrorStr:='     !';
1338:ErrorStr:='     !';
1340:ErrorStr:='      (ACL)    !';
1341:ErrorStr:='    !';
1342:ErrorStr:='    !';
1343:ErrorStr:='     !';
1344:ErrorStr:='    ,    !';
1345:ErrorStr:='          !';
1346:ErrorStr:='         !';
1347:ErrorStr:='       !';
1348:ErrorStr:='     !';
1349:ErrorStr:='     !';
1350:ErrorStr:=',    ,       !';
1351:ErrorStr:='  Windows NT     .   !';
1352:ErrorStr:='  (SAM)    (LSA)     !';
1353:ErrorStr:='      !';
1354:ErrorStr:='       !';
1355:ErrorStr:='   !';
1356:ErrorStr:='   !';
1357:ErrorStr:='       ,   !';
1358:ErrorStr:='     -        !';
1359:ErrorStr:='      !';
1360:ErrorStr:='      ,        !';
1361:ErrorStr:='    !';
1362:ErrorStr:='         .          !';
1363:ErrorStr:='        !';
1364:ErrorStr:='     !';
1365:ErrorStr:='          !';
1366:ErrorStr:='   !';
1367:ErrorStr:='   !';
1368:ErrorStr:='        ,       !';
1369:ErrorStr:='        !';
1370:ErrorStr:='   !';
1371:ErrorStr:='      !';
1372:ErrorStr:='      !';
1373:ErrorStr:='      !';
1374:ErrorStr:='    ,       !';
1375:ErrorStr:='     !';
1376:ErrorStr:='    !';
1377:ErrorStr:='      !';
1378:ErrorStr:='      !';
1379:ErrorStr:='    !';
1380:ErrorStr:='    :           !';
1381:ErrorStr:='     /   !';
1382:ErrorStr:='     !';
1383:ErrorStr:='      !';
1384:ErrorStr:='          !';
1385:ErrorStr:='    :           !';
1386:ErrorStr:='     !';
1387:ErrorStr:='      ,     !';
1388:ErrorStr:='      ,        !';
1389:ErrorStr:='    !';
1390:ErrorStr:='     !';
1391:ErrorStr:='   (ACL)    !';
1392:ErrorStr:=' ( ) .  !';
1393:ErrorStr:='  .  !';
1394:ErrorStr:='         !';
1395:ErrorStr:='    .      !';
1400:ErrorStr:='  !';
1401:ErrorStr:='  !';
1402:ErrorStr:='  !';
1403:ErrorStr:='    !';
1404:ErrorStr:='  !';
1405:ErrorStr:='   !';
1406:ErrorStr:='      !';
1407:ErrorStr:='    !';
1408:ErrorStr:='    !';
1409:ErrorStr:='   !';
1410:ErrorStr:='  !';
1411:ErrorStr:='  !';
1412:ErrorStr:='  ,   , !';
1413:ErrorStr:=' !';
1414:ErrorStr:='  !';
1415:ErrorStr:='  ,      private!';
1416:ErrorStr:='   !';
1417:ErrorStr:='   !';
1418:ErrorStr:='      !';
1419:ErrorStr:='   !';
1420:ErrorStr:='    !';
1421:ErrorStr:='    !';
1422:ErrorStr:='      (    )!';
1423:ErrorStr:='     !';
1424:ErrorStr:='    256!';
1425:ErrorStr:='    (DC)!';
1426:ErrorStr:='   !';
1427:ErrorStr:='  !';
1428:ErrorStr:='      !';
1429:ErrorStr:='      !';
1430:ErrorStr:='     !';
1431:ErrorStr:='   !';
1432:ErrorStr:='    !';
1433:ErrorStr:=' LBSETCOUNT    !';
1434:ErrorStr:='      ,     !';
1435:ErrorStr:='  ,    !';
1436:ErrorStr:='     !';
1437:ErrorStr:='    !';
1438:ErrorStr:='   !';
1439:ErrorStr:='   (SPI*)!';
1440:ErrorStr:='  !';
1441:ErrorStr:='  ,    ,     !';
1442:ErrorStr:='   !';
1443:ErrorStr:='  GW*!';
1444:ErrorStr:='   !';
1445:ErrorStr:='    ,     (MDI) !';
1446:ErrorStr:='   !';
1447:ErrorStr:='    !';
1448:ErrorStr:='          07FFF!';
1449:ErrorStr:='      !';
1500:ErrorStr:='  !';
1501:ErrorStr:='     .    !';
1502:ErrorStr:='  !';
1503:ErrorStr:='         !';
1784:ErrorStr:='      !';
1785:ErrorStr:='    .    !';
1786:ErrorStr:='     !';
1787:ErrorStr:='       Windows NT             !';
1788:ErrorStr:='       -  !';
1789:ErrorStr:='           !';
1790:ErrorStr:='    !';
1791:ErrorStr:='       !';
1792:ErrorStr:='        !';
1793:ErrorStr:='     !';
1794:ErrorStr:='       !';
1795:ErrorStr:='    !';
1796:ErrorStr:='   !';
1797:ErrorStr:='  !';
1798:ErrorStr:='  !';
1799:ErrorStr:='-  !';
1800:ErrorStr:='  !';
1801:ErrorStr:='   !';
1802:ErrorStr:='  !';
1803:ErrorStr:='  !';
1804:ErrorStr:='   !';
1805:ErrorStr:='  !';
1806:ErrorStr:='  !';
1807:ErrorStr:='    .           !';
1808:ErrorStr:='   .           !';
1809:ErrorStr:='    .           ! ';
1810:ErrorStr:='     (SID)    ,      !';
1811:ErrorStr:='      !';
1812:ErrorStr:='      !';
1813:ErrorStr:='      !';
1814:ErrorStr:='       !';
1815:ErrorStr:='       !';
1816:ErrorStr:='   !';
1901:ErrorStr:='  !';
1902:ErrorStr:='   !';
1903:ErrorStr:='   !';
1904:ErrorStr:='    !';
1905:ErrorStr:='   !';
1906:ErrorStr:='  !';
1907:ErrorStr:='       !';
1908:ErrorStr:='     !';
1909:ErrorStr:='            !';
6118:ErrorStr:='      !';
2000:ErrorStr:='  !';
2001:ErrorStr:='  !';
2002:ErrorStr:='      !';
2003:ErrorStr:='     !';
2004:ErrorStr:='    !';
2005:ErrorStr:='     !';
3000:ErrorStr:='   !';
3001:ErrorStr:='   !';
3002:ErrorStr:='    !';
3003:ErrorStr:='    StartDocPrinter!';
3004:ErrorStr:='    AddJob!';
3005:ErrorStr:='    !';
3006:ErrorStr:='    !';
4000:ErrorStr:=' WINS   !';
4001:ErrorStr:='    WINS!';
4002:ErrorStr:='    !';
4003:ErrorStr:='   !';
4004:ErrorStr:='   .  ,     !';
4005:ErrorStr:='      WINS!';
4006:ErrorStr:='    !';

  Else
    ErrorStr:=' !';
  End;{Case}
end;

Procedure SysErrorMessage(ErrorCode:Integer);
begin
  MessageBox(0,PChar(ErrorStr(ErrorCode)),'!',MB_OK OR MB_ICONERROR);
End;

Procedure SysErrorMessageC();
begin
  SysErrorMessage(GetLastError);
end;

Procedure SysErrorMessageCA(MText:String);
var
  TextString : String;
begin
  TextString:=MText+ErrorStr(GetLastError);
  MessageBox(0,PChar(TextString),'!',MB_OK OR MB_ICONERROR);
end;

Procedure SysLog(FileName,MText:String);
var
  F: Text;
Begin
  //  ?
  {$I-}
  AssignFile(F, FileName);
  Reset(F);
  CloseFile(F);
  {$I+}
  if ((IOResult = 0) and (FileName <> '')) then
  //       
    begin
      AssignFile(F, FileName);
      Append(F);
      WriteLN(F,MText);
      CloseFile(F);
    end
  else
  // ,    !
    begin
      AssignFile(F, FileName);
      Rewrite(F);
      WriteLN(F,MText);
      CloseFile(F);
      MessageBox(0,PChar('  : '+FileName),'!',MB_OK+MB_ICONINFORMATION);
    end;

end;

Procedure SysErrorLogCA(FileName,MText:String;MsgBox:Boolean);
var
  OutText : String;
begin
  OutText:=TimeToStr(Time)+' '+DateToStr(Date)+' --> '+MText + ErrorStr(GetLastError);
  if MsgBox then
    SysErrorMessageCA(MText);
  SysLog(FileName,OutText);
end;


end.
